diff -pudr wmhdplop-0.9.9/devnames.h wmhdplop-0.9.9-fixed/devnames.h
--- wmhdplop-0.9.9/devnames.h	2004-04-07 01:14:01.000000000 +0200
+++ wmhdplop-0.9.9-fixed/devnames.h	2010-06-25 21:56:10.662190796 +0200
@@ -9,7 +9,7 @@ typedef struct DiskList {
   unsigned major, minor;
   int hd_id, part_id; /* part_id = 0 for disks */
   int enable_hddtemp;
-  int nr, nw, touched_r, touched_w;
+  long nr, nw, touched_r, touched_w;
   struct DiskList *next;
 } DiskList;
 
diff -pudr wmhdplop-0.9.9/procstat.c wmhdplop-0.9.9-fixed/procstat.c
--- wmhdplop-0.9.9/procstat.c	2007-04-20 11:12:16.000000000 +0200
+++ wmhdplop-0.9.9-fixed/procstat.c	2010-06-25 21:55:37.086191145 +0200
@@ -8,7 +8,7 @@
 static ProcStats ps;
 int use_proc_diskstats;
 
-void pstat_init(struct pstat *pst, int nslice, float update_interval) {
+void pstat_init(struct pstat *pst, long nslice, float update_interval) {
   pst->nslice = nslice;
   ALLOC_VEC(pst->slices, nslice);
   pst->cur_slice = 0;
@@ -17,7 +17,7 @@ void pstat_init(struct pstat *pst, int n
 }
 
 float pstat_current(struct pstat *pst) {
-  int idx = pst->cur_slice ? pst->cur_slice-1 : pst->nslice-1;
+  long idx = pst->cur_slice ? pst->cur_slice-1 : pst->nslice-1;
   return pst->slices[idx]/pst->update_interval;
 }
 
@@ -101,13 +101,13 @@ void update_stats() {
             if (!Prefs.debug_disk_rd) {
               pstat_add(&ps.disk_read, nr);
             } else {
-              static int cntr = 0; cntr+=(rand()%30) == 0 ? Prefs.debug_disk_rd : 0;
+              static long cntr = 0; cntr+=(rand()%30) == 0 ? Prefs.debug_disk_rd : 0;
               pstat_add(&ps.disk_read, nr + cntr);
             }
             if (!Prefs.debug_disk_wr) {
               pstat_add(&ps.disk_write, nw);
             } else {
-              static int cntw = 0; cntw+=(rand()%30) == 0 ? Prefs.debug_disk_wr : 0;
+              static long cntw = 0; cntw+=(rand()%30) == 0 ? Prefs.debug_disk_wr : 0;
               pstat_add(&ps.disk_write, nw + cntw);
             }
             readok = 2;
@@ -121,7 +121,7 @@ void update_stats() {
               pstat_add(&ps.swap_in, nr);
               pstat_add(&ps.swap_out, nw);
             } else {
-              static int cnt = 0; cnt+=Prefs.debug_swapio;
+              static long cnt = 0; cnt+=Prefs.debug_swapio;
               pstat_add(&ps.swap_in, nr + cnt);
               pstat_add(&ps.swap_out, nw + cnt);
             }
@@ -144,10 +144,10 @@ void init_stats(float update_interval) {
   char s[512];
   FILE *f;
 
-  pstat_init(&ps.swap_in, (int)(0.5/update_interval)+1, update_interval);
-  pstat_init(&ps.swap_out, (int)(0.5/update_interval)+1, update_interval);
-  pstat_init(&ps.disk_read, (int)(0.5/update_interval)+1, update_interval);
-  pstat_init(&ps.disk_write, (int)(0.5/update_interval)+1, update_interval);
+  pstat_init(&ps.swap_in, (long)(0.5/update_interval)+1, update_interval);
+  pstat_init(&ps.swap_out, (long)(0.5/update_interval)+1, update_interval);
+  pstat_init(&ps.disk_read, (long)(0.5/update_interval)+1, update_interval);
+  pstat_init(&ps.disk_write, (long)(0.5/update_interval)+1, update_interval);
   f = fopen("/proc/swaps","r");
   //if (!f) { perror("/proc/swaps"); exit(1); }
   if (f) {
diff -pudr wmhdplop-0.9.9/procstat.h wmhdplop-0.9.9-fixed/procstat.h
--- wmhdplop-0.9.9/procstat.h	2004-03-14 12:07:15.000000000 +0100
+++ wmhdplop-0.9.9-fixed/procstat.h	2010-06-25 21:45:52.146334994 +0200
@@ -4,7 +4,7 @@
 
 struct pstat {
   unsigned long total;
-  int nslice, cur_slice;
+  long nslice, cur_slice;
   unsigned long *slices;
   float update_interval;
 };
@@ -15,7 +15,7 @@ typedef struct {
   struct pstat disk_read, disk_write;
 } ProcStats;
 
-void pstat_init(struct pstat *pst, int nslice, float update_interval);
+void pstat_init(struct pstat *pst, long nslice, float update_interval);
 float pstat_current(struct pstat *pst);
 void pstat_add(struct pstat *pst, unsigned long v);
 void pstat_advance(struct pstat *pst);
